#include "ArbDraw.h"

ArbDraw::ArbDraw(rt_arb_internal *arb)
    :
    arb(arb)
{
}

void ArbDraw::autoScale()
{
    if (arb == nullptr)
        return;

    fastf_t m = 0;

    for (const fastf_t* p : arb->pt)
        for (int i = 0; i < 3; i++)
            if (p[i] > m)
                m = p[i];

    if (m != 0)
        setScale(0.9f / m);
}

void ArbDraw::setArb(rt_arb_internal *arb)
{
    this->arb = arb;
}

rt_arb_internal* ArbDraw::getArb()
{
    return arb;
}

void ArbDraw::draw()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glPointSize(3.0f);

    float sc = getScale();
    fastf_t *p;
    
    glBegin(GL_LINE_LOOP);

    for (int i = 0; i < 4; i++) {
        p = arb->pt[i];
        glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);
    }

    glEnd();

    glBegin(GL_LINE_LOOP);    

    for (int i = 4; i < 8; i++) {
        p = arb->pt[i];
        glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);
    }    
    
    glEnd();

    glBegin(GL_LINE_LOOP);

    p = arb->pt[0];
    glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);
    p = arb->pt[4];
    glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);    

    glEnd();

    glBegin(GL_LINE_LOOP);

    p = arb->pt[1];
    glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);
    p = arb->pt[5];
    glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);    

    glEnd();

    glBegin(GL_LINE_LOOP);

    p = arb->pt[2];
    glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);
    p = arb->pt[6];
    glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);    

    glEnd();

    glBegin(GL_LINE_LOOP);

    p = arb->pt[3];
    glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);
    p = arb->pt[7];
    glVertex3f(p[0] * sc, p[1] * sc, p[2] * sc);    

    glEnd();
}
