#ifndef MODEL_H
#define MODEL_H

#include "MyWindow.h"
#include <vector>
#include <string>

class MyWindow;

class Model
{
public:
    virtual void addView(View*) = 0;

    virtual void removeView(View*) = 0;

    virtual void loadDatabase(const std::string&) = 0;

    virtual bool isLoaded() const = 0;

    virtual std::string getTitle() const = 0;

    virtual std::vector<std::string> getElements() const = 0;
    
    virtual std::vector<std::string> getExtends(const std::string&)
        const = 0;
};

#endif /* MODEL_H */
