#include "MyController.h"

MyController::MyController(Model* model)
    :
    model(model),
    view(new MyWindow(model, this))
{
    model->addView(view);
}

void MyController::loadDatabase(const std::string &path)
{
    model->loadDatabase(path);

    if (!model->isLoaded())
        view->errorWhileLoading();
}

View* MyController::getView()
{
    return view;
}
