#ifndef MYMODEL_H
#define MYMODEL_H

#include "Model.h"
#include <raytrace.h>
#include <vector>
#include <string>

class MyModel : public Model
{

    std::vector<View*> views;

    struct rt_i *db;

    void notify();
    
public:
    MyModel();

    void addView(View *view) override;

    void removeView(View *view) override;

    void loadDatabase(const std::string&) override;

    bool isLoaded() const override;

    std::string getTitle() const override;

    std::vector<std::string> getElements() const override;

    std::vector<std::string> getExtends(const std::string&)
        const override;
};

#endif /* MYMODEL_H */
