#ifndef MYWINDOW_H
#define MYWINDOW_H

#include "View.h"
#include "Model.h"
#include "Controller.h"
#include "Canvas.h"

#include <QMenu>
#include <QMenuBar>
#include <QAction>
#include <QListWidget>
#include <QPushButton>
#include <QResizeEvent>

class Model;

class MyWindow : public View
{

    Q_OBJECT

public:
    MyWindow(Model *model, Controller *controller,
             QWidget *parent=0);

    void update() override;

    void errorWhileLoading() override;

private:

    /* MVC's model and controller. */
    
    Model *model;

    Controller *controller;

    /* Menu bar and actions. */

    QMenu *brlcadMenu;

    QAction *brlcadTitleAction;

    QAction *brlcadShowElements;

    /* Top element and Element's extend window. */

    QMainWindow elemWindow, extendsWindow;

    /* Lists for displaying top elements and extends. */

    QListWidget list, extendsList;

    QPushButton extendsButton;

    /* Canvas widget */

    Canvas canvas;

    /* setups menus and actions respectively */
    
    void createMenu();

    void createAction();

    /* resize event */
    void resizeEvent(QResizeEvent*) override;

private slots:

    /* Slots for actions. */
    
    void openDatabaseAction();

    void showElementsAction();

    void getExtendsAction();
};

#endif /* MYWINDOW_H */
